from ctypes import *

class C_Library(object):
    def __init__(self, path: str, retype: type):
        self.path: str = path
        self.lib: _DLLT = cdll.LoadLibrary(path)
        self.lib.Main.restype = retype

    def Main(self, *args):
        return self.lib.main(*args)

    def destructor(self):
        self.lib.destructor()
        del self.lib.destructor

    def other(self, name: str, retype: type, *args):
        local_func = getattr(self.lib, name)
        local_func.restype = retype
        return local_func(*args)
